#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ve = vector<ll>;
#define pb push_back

const ll N=3e5+5;
ll a[N],pref[N],s[4*N];

void build(ll v, ll l, ll r) {
    if (l==r) {
        s[v]=a[l]; return;
    }
    ll m=l+(r-l)/2;
    build(v*2, l, m);
    build(v*2+1, m+1, r);
    s[v]=min(s[v*2], s[v*2+1]);
}
ll query(ll v, ll l, ll r, ll aa, ll bb) {
    if (l==aa && r==bb) return s[v];
    ll m=l+(r-l)/2;
    if (bb<=m) return query(v*2, l, m, aa, bb);
    if (aa>m) return query(v*2+1, m+1, r, aa, bb);
    return min(query(v*2, l, m, aa, m),query(v*2+1,m+1,r,m+1,bb));
}

void sol() {
    ll i,n,k; cin>>n>>k;
    for (i=1;i<=n;i++) cin >> a[i];
    pref[0]=0;
    for (i=1;i<=n;i++) pref[i]=pref[i-1]+a[i];
    build(1,1,n);
    ll ans=-1e18;
    for (i=1;i<=k;i++) {
        ll x=1e18;
        if (i>1) x=query(1,1,n,1,i-1);
        if (i<k) x=min(x,query(1,1,n,i+n-k+1,n));
        ll y=pref[i+n-k]-pref[i-1];
        ans=max(ans,y-x);
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    sol();
    return 0;
}