#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ve = vector<ll>;
using dll = deque<ll>;

const ll N=1e5+5;
ll h[N],n;
ll f[N],s[4*N];

void build(ll v, ll l, ll r) {
    if (l==r) {
        s[v]=f[l]; return;
    }
    ll m=l+(r-l)/2;
    build(2*v,l,m);
    build(2*v+1,m+1,r);
    s[v]=s[2*v]+s[2*v+1];
}
void update(ll v, ll l, ll r, ll x, ll y) {
    if (l==r) {
        f[l]=s[v]=0; return;
    }
    ll m=l+(r-l)/2;
    if (x<=m) update(2*v,l,m,x,y);
    if (x>m) update(2*v+1,m+1,r,x,y);
    s[v]=s[2*v]+s[2*v+1];
}
ll query(ll v, ll l, ll r, ll k) {
    ll m=l+(r-l)/2;
    if (l==r) return l;
    if (s[2*v]>=k) return query(2*v,l,m,k);
    else return query(2*v+1,m+1,r,k-s[2*v]);
    // смотрим куда перейти чтобы найти к-й на отрезке, если слева хотя бы к то туда иначе направо
}

ll pos[N],sl[N],sr[N],pref[N];

// ll sm[4*N];
// void buildm(ll v, ll l, ll r) {
//     if (l==r) {
//         sm[v]=h[l]; return;
//     }
//     ll m=l+(r-l)/2;
//     buildm(2*v,l,m);
//     buildm(2*v+1,m+1,r);
//     sm[v]=max(sm[2*v],sm[2*v+1]);
// }
// ll find_max(ll v, ll l, ll r, ll a, ll b) {
//     if (a==l && b==r) return sm[v];
//     ll m=l+(r-l)/2;
//     if (b<=m) return find_max(2*v,l,m,a,b);
//     if (a>m) return find_max(2*v+1,m+1,r,a,b);
//     return max(find_max(2*v,l,m,a,m),find_max(2*v+1,m+1,r,m+1,b));
// }

void sol() {
    ll i; cin >> n;
    for (i=1;i<=n;i++) cin >> h[i];
    for (i=1;i<=n;i++) f[i]=1;
    build(1,1,n);
    for (i=1;i<=n;i++) {
        pos[i]=i; sl[i]=sr[i]=0;
    }
    pref[0]=0; for (i=1;i<=n;i++) pref[i]=pref[i-1]+h[i];
    /////////////////////////
    for (ll Q=1;Q<n;Q++) {
        ll k; cin >> k;
        ll l=query(1,1,n,k); ll m=query(1,1,n,k+1); ll r;
        if ((k+1)==(n+1-Q)) {
            // если последние 2 отрезка объединяем
            r=n;
        } else r=query(1,1,n,k+2)-1;
        ll SL=0,SR=0; ll new_pos;
        ll p=pos[l],q=pos[m];
        ll M1=h[pos[l]],M2=h[pos[m]];
        /////// l,m - концы отрезков k и k+1
        if (M1>=M2) {
            SL=sl[l];
            new_pos=pos[l];
            SR=sr[m]+M2*(q-p-1);
            SR-=(pref[q-1]-pref[p]);
            // посчитали все кроме q , для него 0
        } else {
            SR=sr[m]; new_pos=pos[m];
            SL=sl[l]+M1*(q-p-1);
            SL-=(pref[q-1]-pref[p]);
            // посчитали все кроме p , для него 0
        }
      //  cout << "! " << l << " " << m << " " << r << "\n";
     //   cout << "!! " << sl[l] << " " << sr[m] << "\n";
        cout << SL+SR << "\n";
        update(1,1,n,m,0);
        // убрали отрезок
        sl[l]=SL; sr[l]=SR; pos[l]=new_pos;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    sol();
    return 0;
}