#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ve = vector<ll>;
using dll = deque<ll>;

const ll N=1e5+5,K=19;
ll h[N],n;
ll f[N],s[4*N];

void build(ll v, ll l, ll r) {
    if (l==r) {
        s[v]=f[l]; return;
    }
    ll m=l+(r-l)/2;
    build(2*v,l,m);
    build(2*v+1,m+1,r);
    s[v]=s[2*v]+s[2*v+1];
}
void update(ll v, ll l, ll r, ll x, ll y) {
    if (l==r) {
        f[l]=s[v]=0; return;
    }
    ll m=l+(r-l)/2;
    if (x<=m) update(2*v,l,m,x,y);
    if (x>m) update(2*v+1,m+1,r,x,y);
    s[v]=s[2*v]+s[2*v+1];
}
ll query(ll v, ll l, ll r, ll k) {
    ll m=l+(r-l)/2;
    if (l==r) return l;
    if (s[2*v]>=k) return query(2*v,l,m,k);
    else return query(2*v+1,m+1,r,k-s[2*v]);
    // смотрим куда перейти чтобы найти к-й на отрезке, если слева хотя бы к то туда иначе направо
}

ll pos[N],pref[N];
ll sm[4*N];
void buildm(ll v, ll l, ll r) {
    if (l==r) {
        sm[v]=h[l]; return;
    }
    ll m=l+(r-l)/2;
    buildm(2*v,l,m);
    buildm(2*v+1,m+1,r);
    sm[v]=max(sm[2*v],sm[2*v+1]);
}
ll find_max(ll v, ll l, ll r, ll a, ll b) {
    if (a==l && b==r) return sm[v];
    ll m=l+(r-l)/2;
    if (b<=m) return find_max(2*v,l,m,a,b);
    if (a>m) return find_max(2*v+1,m+1,r,a,b);
    return max(find_max(2*v,l,m,a,m),find_max(2*v+1,m+1,r,m+1,b));
}

ll two[40];
ll nxt[N],prv[N];
ll up[N][21],down[N][21];
ll sup[N][21],sdown[N][21];

ll ans_up(ll l, ll r) {
    if (l==r) return 0;
    ll ans=0, k=K;
    // предполагаем что до конца осталось меньше two[k]
    while (k>0) {
        ll p=up[l][k-1];
        if (p<=r) {
            ans+=sup[l][k-1];
            l=p;
        } else {
            // ниче не делаем
        }
        k--;
    }
    return ans;
}
ll ans_down(ll l, ll r) {
    if (l==r) return 0;
    ll ans=0, k=K;
    while (k>0) {
        ll p=down[r][k-1];
        if (p>=l) {
            ans+=sdown[r][k-1];
            r=p;
        } else {
            // ниче не делаем
        }
        k--;
    }
    return ans;
}

void sol() {
    ll i; cin >> n;
    for (i=1;i<=n;i++) cin >> h[i];
    for (i=1;i<=n;i++) f[i]=1;
    build(1,1,n);
    buildm(1,1,n);
    for (i=1;i<=n;i++) {
        pos[i]=i;
    }
    pref[0]=0; for (i=1;i<=n;i++) pref[i]=pref[i-1]+h[i];

    for (i=1;i<=n;i++) {
        ll l=i,r=n+1;
        while (r-l>1) {
            ll m=l+(r-l)/2;
            if (find_max(1,1,n,i+1,m)<h[i]) l=m; else r=m;
        }
        nxt[i]=r;
    }
    nxt[n+1]=n+1;
    for (i=1;i<=n;i++) {
        ll l=0,r=i;
        while (r-l>1) {
            ll m=l+(r-l)/2;
            if (find_max(1,1,n,m,i-1)<h[i]) r=m; else l=m;
        }
        prv[i]=l;
    }
    prv[0]=0;
    for (i=1;i<=n+1;i++) up[i][0]=nxt[i];
    for (i=0;i<=n;i++) down[i][0]=prv[i];

    for (ll j=1;j<=K;j++) {
        for (i=1;i<=n+1;i++) up[i][j]=up[up[i][j-1]][j-1];
        for (i=0;i<=n;i++) down[i][j]=down[down[i][j-1]][j-1];
    }
    h[0]=h[n+1]=1e9;
    for (i=1;i<=n+1;i++) sup[i][0]=h[i]*(nxt[i]-i);
    for (i=0;i<=n;i++) sdown[i][0]=h[i]*(i-prv[i]);

    for (ll j=1;j<=K;j++) {

        for (i=1;i<=n+1;i++) {
            ll R=up[i][j-1];
            sup[i][j]=sup[i][j-1]+sup[R][j-1];
        }
       for (i=0;i<=n;i++) {
           ll L=down[i][j-1];
           sdown[i][j]=sdown[i][j-1]+sdown[L][j-1];
       }
    }

    /////////////////////////
    for (ll Q=1;Q<n;Q++) {
        ll k; cin >> k;
        ll l=query(1,1,n,k); ll m=query(1,1,n,k+1); ll r;
        if ((k+1)==(n+1-Q)) {
            // если последние 2 отрезка объединяем
            r=n;
        } else r=query(1,1,n,k+2)-1;
        ll M1=h[pos[l]],M2=h[pos[m]];
        ll p; if (M1>=M2) {
            p=pos[l];
        } else {
            p=pos[m];
        }
        ll ans=ans_up(l,p)+ans_down(p,r);
        pos[l]=p;
        update(1,1,n,m,0);
        ans-=(pref[r]-pref[l-1]-h[p]);
        cout << ans << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    two[0]=1; for (ll i=1;i<=24;i++) two[i]=two[i-1]*2;
    sol();
    return 0;
}